/* slotfunc.c - Slot functions
 *
 * gSlots is a slotmachine
 *
 * 1999 Kristian Rietveld <kristian@wxs.nl>
 *
 * this program comes with ABSOLUTELY NO WARRANTY and is published
 * under the terms from the GPL
 *
 */

/* gSlots - a nice slotmachine for Linux/X-windows/GTK+
 * Copyright (C) 1999  Kristian Rietveld <kristian@wxs.nl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "gslots.h"
#include <stdlib.h>

extern int         payoffwindowopened;
extern int         numberofscores;
extern int         slotspix[3][MAX_PIX_AT_SLOT];
extern int         numberofslotspix[3];
extern gfloat      credits;
extern gfloat      wager;
extern gfloat      won;
extern struct      gamewindow gw;
extern struct      scoreentry thescores[MAX_SCORES];

int                heldbuttons[3] = {0,0,0};
struct             payoffpicentry payoffpix[MAX_SCORES][3];
GdkPixmap         *payoffentrypixmap[MAX_SCORES][3];

/* prototypes */
void move_slot(int, int);
void check_hold_buttons();
void reset_hold_buttons();
void check_for_winnings();

void quit_gslots(GtkWidget *widget, gpointer data)
{
  return;
}

void bet_1_more_buck(GtkWidget *widget, gpointer data)
{
  if ( wager < 9.76 )
    wager += 0.25;
  else
    wager = 0.25;

  if ( wager > 10.00)
    wager = 0.25;

  update_score_display(1, wager);

  if (payoffwindowopened)
    payoff_window_new_wager_handle();
  
  return;
}

void bet_max_bucks(GtkWidget *widget, gpointer data)
{
  wager = 10.00;
  update_score_display(1, wager);

  if (payoffwindowopened)
    payoff_window_new_wager_handle();

  return;
}

void check_hold_buttons()
{
  int t = 0;

  for (t = 0; t < 3; t++)
    {
      if (GTK_TOGGLE_BUTTON(gw.holdbuttons[t])->active && heldbuttons[t] < 1)
	heldbuttons[t]++;
      else if (heldbuttons[t] > 0)
	{
	  heldbuttons[t] = 0;
	  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(gw.holdbuttons[t]),
				       FALSE);
	}
      else
	heldbuttons[t] = 0;
    }

  if (heldbuttons[0] > 0 && heldbuttons[1] > 0 && heldbuttons[2] > 0)
    {
      heldbuttons[0] = 0;
      heldbuttons[1] = 0;
      heldbuttons[2] = 0;

      reset_hold_buttons();
    }
  
  return;
}

void reset_hold_buttons()
{
  int t = 0;

  for(t = 0; t < 3; t++)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(gw.holdbuttons[t]),
				 FALSE);
  
  return;
}

void spin_slots(GtkWidget *widget, gpointer data)
{
  int  t = 0;
  int  spins[3];
  char mybuff[64];

  won = 0.0;
  update_score_display(2, won);

  gtk_statusbar_push(GTK_STATUSBAR(gw.statusbar), gw.context_id,
		     "Spinning the slots...");

  check_hold_buttons();

  if ( credits - wager < 0)
    {
      message("Not enough credits to spin. Increase wager.");
      gtk_statusbar_push(GTK_STATUSBAR(gw.statusbar), gw.context_id,
			 "Not enough credits to spin. Increase wager.");
      return;
    }
  else
    {
      credits -= wager;
      update_score_display(0, credits);
    }
  
  spins[0] = (rand() % 7) + 1;
  spins[1] = (rand() % 7) + 1;
  spins[2] = (rand() % 7) + 1;

  for ( t = 0 ; t < (rand() % 2) + 1; t++)
    {
      if ( heldbuttons[0] == 0)
	{
	  move_slot(0, 27);
	  move_slot(0, 28);
	}
      if ( heldbuttons[1] == 0)
	{
	  move_slot(1, 27);
	  move_slot(1, 28);
	}
      if ( heldbuttons[2] == 0)
	{
	  move_slot(2, 27);
	  move_slot(2, 28);
	}
      
      if ( heldbuttons[0] == 0)
	{
	  move_slot(0, 27);
	  move_slot(0, 28);
	}
      if ( heldbuttons[1] == 0)
	{
	  move_slot(1, 27);
	  move_slot(1, 28);
	}
      if ( heldbuttons[2] == 0)
	{
	  move_slot(2, 27);
	  move_slot(2, 28);      
	}
    }
  
  for( t = 0; t < spins[0]; t++)
    {
      if ( heldbuttons[0] == 0)
	{
	  move_slot(0, 27);
	  move_slot(0, 28);
	}
      if ( heldbuttons[1] == 0)
	{
	  move_slot(1, 27);
	  move_slot(1, 28);
	}
      if ( heldbuttons[2] == 0)
	{
	  move_slot(2, 27);
	  move_slot(2, 28);
	}
      
      if ( heldbuttons[0] == 0)
	{
	  move_slot(0, 27);
	  move_slot(0, 28);
	}
      if ( heldbuttons[1] == 0)
	{
	  move_slot(1, 27);
	  move_slot(1, 28);
	}
      if ( heldbuttons[2] == 0)
	{
	  move_slot(2, 27);
	  move_slot(2, 28);
	}
    }
  
  for( t = 0; t < spins[1]; t++)
    {
      if ( heldbuttons[1] == 0)
	{
	  move_slot(1, 27);
	  move_slot(1, 28);
	}
      if ( heldbuttons[2] == 0)
	{
	  move_slot(2, 27);
	  move_slot(2, 28);
	}
      
      if ( heldbuttons[1] == 0)
	{
	  move_slot(1, 27);
	  move_slot(1, 28);
	}
      if ( heldbuttons[2] == 0)
	{
	  move_slot(2, 27);
	  move_slot(2, 28);
	}
    }
  
  for( t = 0; t < spins[2]; t++)
    {
      if ( heldbuttons[2] == 0)
	{
	  move_slot(2, 27);
	  move_slot(2, 28);
	}
      
      if ( heldbuttons[2] == 0)
	{
	  move_slot(2, 27);
	  move_slot(2, 28);
	}
    }

  reset_hold_buttons();

  check_for_winnings();

  sprintf(mybuff, "Won %3.2f", won);
  gtk_statusbar_push(GTK_STATUSBAR(gw.statusbar),
		     gw.context_id, mybuff);

  if (credits <= 0.0)
    {
      message("No more credits.");
      gtk_statusbar_push(GTK_STATUSBAR(gw.statusbar),
			 gw.context_id,
			 "No more credits");
    }

  return;
}

void check_for_winnings()
{
  int t = 0, tt = 0, ttt = 0;
  int thenumber[3][3];

  /*** fetch the pixmapnumber from the pixmaps at the slots ***/

  for ( t = 0; t < 3 ; t++)
    for(tt = 0; tt < 3; tt++)
      if ( gw.slotrotate[tt]/110+t > (MAX_PIX_AT_SLOT - 1))
	{
	  int tmp = (gw.slotrotate[tt]/110 + t) - MAX_PIX_AT_SLOT;
	  
	  thenumber[t][tt] = slotspix[tt][tmp];
	}
      else
	thenumber[t][tt] = slotspix[tt][gw.slotrotate[tt]/110+t];
      
  /*** check if three pixmaps are correct ***/

  for ( t = 0; t < numberofscores; t++)
    {
      for ( tt = 0; tt < 3; tt++)
	{
	  int correct = 0;
	  int used[3] = {0, 0, 0};

	  for ( ttt = 0; ttt < 3; ttt++)
	    {
	      if ( thenumber[tt][ttt] == thescores[t].picatslot[0] &&
		   used[0] == 0)
		{
		  correct++;
		  used[0] = 1;
		}
	      else if ( thenumber[tt][ttt] == thescores[t].picatslot[1] &&
			used[1] == 0)
		{
		  correct++;
		  used[1] = 1;
		}
	      else if ( thenumber[tt][ttt] == thescores[t].picatslot[2] &&
			used[2] == 0)
		{
		  correct++;
		  used[2] = 1;
		}
	    }

	  if ( correct == 3 && used[0] == 1 && used[1] == 1 && used[2]
	       == 1)
	    {
	      won += thescores[t].score * wager;
	      update_score_display(2, won);
	    } 
	}
    }
  
  credits += won;
  update_score_display(0, credits);
  update_score_display(2, won);
}

void move_slot(int slotnum, int pixels)
{
  GdkRectangle update_rect;
  
  if ( gw.slotrotate[slotnum] + pixels == 110*MAX_PIX_AT_SLOT)
    {
      gw.slotrotate[slotnum] = 0;
      
      gdk_draw_pixmap(gw.slot[slotnum],
		      gw.slotdraw[slotnum]->style->black_gc,
		      gw.theslot[slotnum],
		      0, gw.slotrotate[slotnum],
		      0, 0,
		      90, 330);
    }
  else
    {
      if ( gw.slotrotate[slotnum] + pixels > 110*MAX_PIX_AT_SLOT - 110*3)
	{
	  int oldslot;
	  int newslot;

	  gw.slotrotate[slotnum] += pixels;
	  
	  oldslot = 110 * MAX_PIX_AT_SLOT - gw.slotrotate[slotnum];
	  newslot = 3 * 110 - oldslot;
	  
	  gdk_draw_pixmap(gw.slot[slotnum],
			  gw.slotdraw[slotnum]->style->black_gc,
			  gw.theslot[slotnum],
			  0, gw.slotrotate[slotnum],
			  0, 0,
			  90, oldslot);
	
	  gdk_draw_pixmap(gw.slot[slotnum],
			  gw.slotdraw[slotnum]->style->black_gc,
			  gw.theslot[slotnum],
			  0, 0,
			  0, oldslot,
			  90, newslot);
	}
      else
	{
	  gw.slotrotate[slotnum] += pixels;

	  gdk_draw_pixmap(gw.slot[slotnum],
			  gw.slotdraw[slotnum]->style->black_gc,
			  gw.theslot[slotnum],
			  0, gw.slotrotate[slotnum],
			  0, 0,
			  90, 330);
	}

    }

  update_rect.x = 0;
  update_rect.y = 0;
  update_rect.width = 90;
  update_rect.height = 330;

  gtk_widget_draw(gw.slotdraw[slotnum], &update_rect);

  return;
}
